"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.diffVariablesForOperation = exports.assertIsGraphQL = void 0;
const jest_matcher_utils_1 = require("jest-matcher-utils");
const graphql_controller_1 = require("../graphql-controller");
function assertIsGraphQL(graphQL, { expectation, isNot }) {
    if (!(graphQL instanceof graphql_controller_1.GraphQL)) {
        throw new Error(jest_matcher_utils_1.matcherErrorMessage(jest_matcher_utils_1.matcherHint(`.${expectation}`, undefined, undefined, { isNot }), `${jest_matcher_utils_1.RECEIVED_COLOR('received')} value must be a @shopify/graphql-testing GraphQL object`, jest_matcher_utils_1.printWithType('Received', graphQL, jest_matcher_utils_1.printReceived)));
    }
}
exports.assertIsGraphQL = assertIsGraphQL;
function diffVariablesForOperation(operation, variables, { expand = false }) {
    return jest_matcher_utils_1.diff(variables, getObjectSubset(operation.variables, variables), {
        expand,
    });
}
exports.diffVariablesForOperation = diffVariablesForOperation;
// Original from https://github.com/facebook/jest/blob/master/packages/expect/src/utils.ts#L107
function getObjectSubset(object, subset) {
    if (Array.isArray(object)) {
        if (Array.isArray(subset) && subset.length === object.length) {
            return subset.map((sub, i) => getObjectSubset(object[i], sub));
        }
    }
    else if (object instanceof Date) {
        return object;
    }
    else if (typeof object === 'object' &&
        object !== null &&
        typeof subset === 'object' &&
        subset !== null) {
        const trimmed = {};
        Object.keys(subset)
            .filter(key => Reflect.has(object, key))
            .forEach(key => (trimmed[key] = getObjectSubset(object[key], subset[key])));
        if (Object.keys(trimmed).length > 0) {
            return trimmed;
        }
    }
    return object;
}
