"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Operations = void 0;
const utilities_1 = require("./utilities");
class Operations {
    constructor(operations) {
        this.operations = [];
        this.operations = operations ? [...operations] : [];
    }
    [Symbol.iterator]() {
        return this.operations[Symbol.iterator]();
    }
    push(...operations) {
        this.operations.push(...operations);
    }
    all(options) {
        return this.filterWhere(options);
    }
    first(options) {
        return this.nth(0, options);
    }
    last(options) {
        return this.nth(-1, options);
    }
    nth(index, options) {
        const found = this.filterWhere(options);
        return index < 0 ? found[found.length + index] : found[index];
    }
    filterWhere(options = {}) {
        const finalOperationName = utilities_1.operationNameFromFindOptions(options);
        return finalOperationName
            ? this.operations.filter(({ operationName }) => operationName === finalOperationName)
            : this.operations;
    }
}
exports.Operations = Operations;
