"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.operationTypeFromDocument = exports.operationNameFromDocument = exports.operationNameFromFindOptions = void 0;
function operationNameFromFindOptions({ query, mutation, operationName, }) {
    const passedOptions = [query, mutation, operationName].filter(Boolean);
    if (passedOptions.length === 0) {
        return undefined;
    }
    else if (passedOptions.length > 1) {
        throw new Error('You can only pass one of query, mutation, or operationName when finding a GraphQL operation');
    }
    return operationName || operationNameFromDocument((query || mutation));
}
exports.operationNameFromFindOptions = operationNameFromFindOptions;
function operationNameFromDocument(document) {
    return 'resolver' in document && document.resolver.resolved != null
        ? operationNameFromDocumentNode(document.resolver.resolved)
        : operationNameFromDocumentNode(document);
}
exports.operationNameFromDocument = operationNameFromDocument;
function operationTypeFromDocument(document) {
    return 'resolver' in document && document.resolver.resolved != null
        ? operationTypeFromDocumentNode(document.resolver.resolved)
        : operationTypeFromDocumentNode(document);
}
exports.operationTypeFromDocument = operationTypeFromDocument;
function operationNameFromDocumentNode(document) {
    const [operation] = document.definitions.filter(({ kind }) => kind === 'OperationDefinition');
    return operation && operation.name && operation.name.value;
}
function operationTypeFromDocumentNode(document) {
    const [operation] = document.definitions.filter(({ kind }) => kind === 'OperationDefinition');
    return operation && operation.operation;
}
